#include <stdio.h>
#include <stdlib.h>

int main()
{
  char buf[32];
  int r;

  r = sprintf(buf, "%3d", 1);
  printf("%s %d\n", buf, r);

  r = sprintf(buf, "%3d", 12345);
  printf("%s %d\n", buf, r);

  r = sprintf(buf, "%03d", 1);
  printf("%s %d\n", buf, r);

  r = sprintf(buf, "%03d", 12345);
  printf("%s %d\n", buf, r);

  r = sprintf(buf, "%02x", 0xf);
  printf("%s %d\n", buf, r);

  r = sprintf(buf, "%02x", 0xabcd);
  printf("%s %d\n", buf, r);

  r = sprintf(buf, "%5s", "abc");
  printf("%s %d\n", buf, r);

  r = sprintf(buf, "%5s", "abcdefg");
  printf("%s %d\n", buf, r);

  r = sprintf(buf, "%5p", NULL);
  printf("%s %d\n", buf, r);

  r = sprintf(buf, "%3d %d %03d", 1, 2, 3);
  printf("%s %d\n", buf, r);

  r = sprintf(buf, "%3d %d %03d", 12345, 98765, 13579);
  printf("%s %d\n", buf, r);

  r = sprintf(buf, "%2x %x %02x", 0xa, 0xb, 0xc);
  printf("%s %d\n", buf, r);

  r = sprintf(buf, "%2x %x %02x", 0xabcd, 0xfedc, 0xacbd);
  printf("%s %d\n", buf, r);

  r = sprintf(buf, "%5s %s", "abc", "abc");
  printf("%s %d\n", buf, r);

  r = sprintf(buf, "%5s %s", "abcdefg", "abcdefg");
  printf("%s %d\n", buf, r);

  r = sprintf(buf, "%3d %d %03d %2x %x %02x %5s %s",
	      1, 2, 3, 0xa, 0xb, 0xc, "abc", "abc");
  printf("%s %d\n", buf, r);

  return 0;
}
